// Compiled by ClojureScript 1.9.562 {}
goog.provide('hoplon.jquery');
goog.require('cljs.core');
goog.require('hoplon.core');
hoplon.jquery.set_attributes_BANG_ = (function hoplon$jquery$set_attributes_BANG_(var_args){
var args30338 = [];
var len__24369__auto___30357 = arguments.length;
var i__24370__auto___30358 = (0);
while(true){
if((i__24370__auto___30358 < len__24369__auto___30357)){
args30338.push((arguments[i__24370__auto___30358]));

var G__30359 = (i__24370__auto___30358 + (1));
i__24370__auto___30358 = G__30359;
continue;
} else {
}
break;
}

var G__30344 = args30338.length;
switch (G__30344) {
case 2:
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__24392__auto__ = (new cljs.core.IndexedSeq(args30338.slice((3)),(0),null));
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__24392__auto__);

}
});

hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (this$,kvs){
var e = jQuery(this$);
var seq__30345 = cljs.core.seq.call(null,kvs);
var chunk__30347 = null;
var count__30348 = (0);
var i__30349 = (0);
while(true){
if((i__30349 < count__30348)){
var vec__30351 = cljs.core._nth.call(null,chunk__30347,i__30349);
var k = cljs.core.nth.call(null,vec__30351,(0),null);
var v = cljs.core.nth.call(null,vec__30351,(1),null);
var k_30361__$1 = cljs.core.name.call(null,k);
if(cljs.core.not.call(null,v)){
e.removeAttr(k_30361__$1);
} else {
e.attr(k_30361__$1,((cljs.core._EQ_.call(null,true,v))?k_30361__$1:v));
}

var G__30362 = seq__30345;
var G__30363 = chunk__30347;
var G__30364 = count__30348;
var G__30365 = (i__30349 + (1));
seq__30345 = G__30362;
chunk__30347 = G__30363;
count__30348 = G__30364;
i__30349 = G__30365;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30345);
if(temp__5278__auto__){
var seq__30345__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30345__$1)){
var c__24059__auto__ = cljs.core.chunk_first.call(null,seq__30345__$1);
var G__30366 = cljs.core.chunk_rest.call(null,seq__30345__$1);
var G__30367 = c__24059__auto__;
var G__30368 = cljs.core.count.call(null,c__24059__auto__);
var G__30369 = (0);
seq__30345 = G__30366;
chunk__30347 = G__30367;
count__30348 = G__30368;
i__30349 = G__30369;
continue;
} else {
var vec__30354 = cljs.core.first.call(null,seq__30345__$1);
var k = cljs.core.nth.call(null,vec__30354,(0),null);
var v = cljs.core.nth.call(null,vec__30354,(1),null);
var k_30370__$1 = cljs.core.name.call(null,k);
if(cljs.core.not.call(null,v)){
e.removeAttr(k_30370__$1);
} else {
e.attr(k_30370__$1,((cljs.core._EQ_.call(null,true,v))?k_30370__$1:v));
}

var G__30371 = cljs.core.next.call(null,seq__30345__$1);
var G__30372 = null;
var G__30373 = (0);
var G__30374 = (0);
seq__30345 = G__30371;
chunk__30347 = G__30372;
count__30348 = G__30373;
i__30349 = G__30374;
continue;
}
} else {
return null;
}
}
break;
}
});

hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (this$,k,v,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,this$,cljs.core.apply.call(null,cljs.core.hash_map,k,v,kvs));
});

hoplon.jquery.set_attributes_BANG_.cljs$lang$applyTo = (function (seq30339){
var G__30340 = cljs.core.first.call(null,seq30339);
var seq30339__$1 = cljs.core.next.call(null,seq30339);
var G__30341 = cljs.core.first.call(null,seq30339__$1);
var seq30339__$2 = cljs.core.next.call(null,seq30339__$1);
var G__30342 = cljs.core.first.call(null,seq30339__$2);
var seq30339__$3 = cljs.core.next.call(null,seq30339__$2);
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__30340,G__30341,G__30342,seq30339__$3);
});

hoplon.jquery.set_attributes_BANG_.cljs$lang$maxFixedArity = (3);

hoplon.jquery.set_styles_BANG_ = (function hoplon$jquery$set_styles_BANG_(var_args){
var args30375 = [];
var len__24369__auto___30392 = arguments.length;
var i__24370__auto___30393 = (0);
while(true){
if((i__24370__auto___30393 < len__24369__auto___30392)){
args30375.push((arguments[i__24370__auto___30393]));

var G__30394 = (i__24370__auto___30393 + (1));
i__24370__auto___30393 = G__30394;
continue;
} else {
}
break;
}

var G__30381 = args30375.length;
switch (G__30381) {
case 2:
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__24392__auto__ = (new cljs.core.IndexedSeq(args30375.slice((3)),(0),null));
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__24392__auto__);

}
});

hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (this$,kvs){
var e = jQuery(this$);
var seq__30382 = cljs.core.seq.call(null,kvs);
var chunk__30383 = null;
var count__30384 = (0);
var i__30385 = (0);
while(true){
if((i__30385 < count__30384)){
var vec__30386 = cljs.core._nth.call(null,chunk__30383,i__30385);
var k = cljs.core.nth.call(null,vec__30386,(0),null);
var v = cljs.core.nth.call(null,vec__30386,(1),null);
e.css(cljs.core.name.call(null,k),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));

var G__30396 = seq__30382;
var G__30397 = chunk__30383;
var G__30398 = count__30384;
var G__30399 = (i__30385 + (1));
seq__30382 = G__30396;
chunk__30383 = G__30397;
count__30384 = G__30398;
i__30385 = G__30399;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30382);
if(temp__5278__auto__){
var seq__30382__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30382__$1)){
var c__24059__auto__ = cljs.core.chunk_first.call(null,seq__30382__$1);
var G__30400 = cljs.core.chunk_rest.call(null,seq__30382__$1);
var G__30401 = c__24059__auto__;
var G__30402 = cljs.core.count.call(null,c__24059__auto__);
var G__30403 = (0);
seq__30382 = G__30400;
chunk__30383 = G__30401;
count__30384 = G__30402;
i__30385 = G__30403;
continue;
} else {
var vec__30389 = cljs.core.first.call(null,seq__30382__$1);
var k = cljs.core.nth.call(null,vec__30389,(0),null);
var v = cljs.core.nth.call(null,vec__30389,(1),null);
e.css(cljs.core.name.call(null,k),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));

var G__30404 = cljs.core.next.call(null,seq__30382__$1);
var G__30405 = null;
var G__30406 = (0);
var G__30407 = (0);
seq__30382 = G__30404;
chunk__30383 = G__30405;
count__30384 = G__30406;
i__30385 = G__30407;
continue;
}
} else {
return null;
}
}
break;
}
});

hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (this$,k,v,kvs){
return hoplon.jquery.set_styles_BANG_.call(null,this$,cljs.core.apply.call(null,cljs.core.hash_map,k,v,kvs));
});

hoplon.jquery.set_styles_BANG_.cljs$lang$applyTo = (function (seq30376){
var G__30377 = cljs.core.first.call(null,seq30376);
var seq30376__$1 = cljs.core.next.call(null,seq30376);
var G__30378 = cljs.core.first.call(null,seq30376__$1);
var seq30376__$2 = cljs.core.next.call(null,seq30376__$1);
var G__30379 = cljs.core.first.call(null,seq30376__$2);
var seq30376__$3 = cljs.core.next.call(null,seq30376__$2);
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__30377,G__30378,G__30379,seq30376__$3);
});

hoplon.jquery.set_styles_BANG_.cljs$lang$maxFixedArity = (3);

hoplon.jquery.text_val_BANG_ = (function hoplon$jquery$text_val_BANG_(var_args){
var args30408 = [];
var len__24369__auto___30411 = arguments.length;
var i__24370__auto___30412 = (0);
while(true){
if((i__24370__auto___30412 < len__24369__auto___30411)){
args30408.push((arguments[i__24370__auto___30412]));

var G__30413 = (i__24370__auto___30412 + (1));
i__24370__auto___30412 = G__30413;
continue;
} else {
}
break;
}

var G__30410 = args30408.length;
switch (G__30410) {
case 1:
return hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args30408.length)].join('')));

}
});

hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$1 = (function (e){
return e.val();
});

hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (e,v){
var v__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join('');
if(cljs.core.not_EQ_.call(null,v__$1,hoplon.jquery.text_val_BANG_.call(null,e))){
return e.val(v__$1);
} else {
return null;
}
});

hoplon.jquery.text_val_BANG_.cljs$lang$maxFixedArity = 2;

hoplon.jquery.check_val_BANG_ = (function hoplon$jquery$check_val_BANG_(var_args){
var args30415 = [];
var len__24369__auto___30418 = arguments.length;
var i__24370__auto___30419 = (0);
while(true){
if((i__24370__auto___30419 < len__24369__auto___30418)){
args30415.push((arguments[i__24370__auto___30419]));

var G__30420 = (i__24370__auto___30419 + (1));
i__24370__auto___30419 = G__30420;
continue;
} else {
}
break;
}

var G__30417 = args30415.length;
switch (G__30417) {
case 1:
return hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args30415.length)].join('')));

}
});

hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$1 = (function (e){
return e.is(":checked");
});

hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (e,v){
return e.prop("checked",cljs.core.boolean$.call(null,v));
});

hoplon.jquery.check_val_BANG_.cljs$lang$maxFixedArity = 2;

cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("hoplon.core","default","hoplon.core/default",-778824365),(function (elem,key,val){
return hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"attr","attr",-604132353),cljs.core.PersistentArrayMap.createAsIfByAssoc([key,val]));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("css","*","css/*",-1295355419),(function (elem,key,val){
return hoplon.jquery.set_styles_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("html","*","html/*",-1283138243),(function (elem,key,val){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("svg","*","svg/*",-1295405562),(function (elem,key,val){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("attr","*","attr/*",-1283077225),(function (elem,_,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("prop","*","prop/*",-1283942139),(function (elem,key,val){
var e = jQuery(elem);
return e.prop(cljs.core.name.call(null,key),val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("data","*","data/*",-1283013312),(function (elem,key,val){
var e = jQuery(elem);
return e.data(cljs.core.name.call(null,key),val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"attr","attr",-604132353),(function (elem,_,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"css","css",1135045163),(function (elem,_,kvs){
return hoplon.jquery.set_styles_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"value","value",305978217),(function() { 
var G__30422__delegate = function (elem,_,args){
var e = jQuery(elem);
return cljs.core.apply.call(null,((cljs.core._EQ_.call(null,"checkbox",e.attr("type")))?hoplon.jquery.check_val_BANG_:hoplon.jquery.text_val_BANG_),e,args);
};
var G__30422 = function (elem,_,var_args){
var args = null;
if (arguments.length > 2) {
var G__30423__i = 0, G__30423__a = new Array(arguments.length -  2);
while (G__30423__i < G__30423__a.length) {G__30423__a[G__30423__i] = arguments[G__30423__i + 2]; ++G__30423__i;}
  args = new cljs.core.IndexedSeq(G__30423__a,0,null);
} 
return G__30422__delegate.call(this,elem,_,args);};
G__30422.cljs$lang$maxFixedArity = 2;
G__30422.cljs$lang$applyTo = (function (arglist__30424){
var elem = cljs.core.first(arglist__30424);
arglist__30424 = cljs.core.next(arglist__30424);
var _ = cljs.core.first(arglist__30424);
var args = cljs.core.rest(arglist__30424);
return G__30422__delegate(elem,_,args);
});
G__30422.cljs$core$IFn$_invoke$arity$variadic = G__30422__delegate;
return G__30422;
})()
);
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"class","class",-2030961996),(function (elem,_,kvs){
var elem__$1 = jQuery(elem);
var clmap = hoplon.core.normalize_class.call(null,kvs);
var seq__30425 = cljs.core.seq.call(null,clmap);
var chunk__30426 = null;
var count__30427 = (0);
var i__30428 = (0);
while(true){
if((i__30428 < count__30427)){
var vec__30429 = cljs.core._nth.call(null,chunk__30426,i__30428);
var c = cljs.core.nth.call(null,vec__30429,(0),null);
var p_QMARK_ = cljs.core.nth.call(null,vec__30429,(1),null);
elem__$1.toggleClass(cljs.core.name.call(null,c),cljs.core.boolean$.call(null,p_QMARK_));

var G__30435 = seq__30425;
var G__30436 = chunk__30426;
var G__30437 = count__30427;
var G__30438 = (i__30428 + (1));
seq__30425 = G__30435;
chunk__30426 = G__30436;
count__30427 = G__30437;
i__30428 = G__30438;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30425);
if(temp__5278__auto__){
var seq__30425__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30425__$1)){
var c__24059__auto__ = cljs.core.chunk_first.call(null,seq__30425__$1);
var G__30439 = cljs.core.chunk_rest.call(null,seq__30425__$1);
var G__30440 = c__24059__auto__;
var G__30441 = cljs.core.count.call(null,c__24059__auto__);
var G__30442 = (0);
seq__30425 = G__30439;
chunk__30426 = G__30440;
count__30427 = G__30441;
i__30428 = G__30442;
continue;
} else {
var vec__30432 = cljs.core.first.call(null,seq__30425__$1);
var c = cljs.core.nth.call(null,vec__30432,(0),null);
var p_QMARK_ = cljs.core.nth.call(null,vec__30432,(1),null);
elem__$1.toggleClass(cljs.core.name.call(null,c),cljs.core.boolean$.call(null,p_QMARK_));

var G__30443 = cljs.core.next.call(null,seq__30425__$1);
var G__30444 = null;
var G__30445 = (0);
var G__30446 = (0);
seq__30425 = G__30443;
chunk__30426 = G__30444;
count__30427 = G__30445;
i__30428 = G__30446;
continue;
}
} else {
return null;
}
}
break;
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"toggle","toggle",1291842030),(function (elem,_,v){
return jQuery(elem).toggle(cljs.core.boolean$.call(null,v));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"slide-toggle","slide-toggle",968641513),(function (elem,_,v){
if(cljs.core.truth_(v)){
return jQuery(elem).hide().slideDown("fast");
} else {
return jQuery(elem).slideUp("fast");
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"fade-toggle","fade-toggle",-1468421852),(function (elem,_,v){
if(cljs.core.truth_(v)){
return jQuery(elem).hide().fadeIn("fast");
} else {
return jQuery(elem).fadeOut("fast");
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"focus","focus",234677911),(function (elem,_,v){
return setTimeout((function (){
if(cljs.core.truth_(v)){
return jQuery(elem).focus();
} else {
return jQuery(elem).focusout();
}
}),(0));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"select","select",1147833503),(function (elem,_,___$1){
return jQuery(elem).select();
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"focus-select","focus-select",1107982934),(function (elem,_,v){
if(cljs.core.truth_(v)){
hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"focus","focus",234677911),v);

return hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"select","select",1147833503),v);
} else {
return null;
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"text","text",-1790561697),(function (elem,_,v){
return jQuery(elem).text([cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"html","html",-998796897),(function (elem,_,v){
return jQuery(elem).html(v);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"scroll-to","scroll-to",-34957602),(function (elem,_,v){
if(cljs.core.truth_(v)){
var body = jQuery("body,html");
var elem__$1 = jQuery(elem);
return body.animate(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"scrollTop","scrollTop",-1143661921),elem__$1.offset().top], null)));
} else {
return null;
}
}));
jQuery.Event.prototype.cljs$core$IDeref$ = cljs.core.PROTOCOL_SENTINEL;

jQuery.Event.prototype.cljs$core$IDeref$_deref$arity$1 = (function (this$){
var this$__$1 = this;
return jQuery(this$__$1.target).val();
});
cljs.core._add_method.call(null,hoplon.core.on_BANG_,new cljs.core.Keyword("hoplon.core","default","hoplon.core/default",-778824365),(function (elem,event,callback){
return hoplon.core.when_dom.call(null,elem,(function (){
return jQuery(elem).on(cljs.core.name.call(null,event),callback);
}));
}));
cljs.core._add_method.call(null,hoplon.core.on_BANG_,new cljs.core.Keyword("html","*","html/*",-1283138243),(function (elem,event,callback){
return hoplon.core.when_dom.call(null,elem,(function (){
return jQuery(elem).on(cljs.core.name.call(null,event),callback);
}));
}));
